Index: trunk/source/processes/electromagnetic/standard/History
===================================================================
--- trunk/source/processes/electromagnetic/standard/History	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/History	(revision 991)
@@ -1,3 +1,3 @@
-$Id: History,v 1.432 2009/02/20 12:11:37 vnivanch Exp $
+$Id: History,v 1.430 2008/11/24 18:28:09 vnivanch Exp $
 -------------------------------------------------------------------
 
@@ -17,13 +17,4 @@
      * Reverse chronological order (last date on top), please *
      ----------------------------------------------------------
-
-20 February 09: V.Ivant (emstand-V09-02-00)
-- Move all virtual methods from inline to source
-G4PEEffectModel - substitute ComputeMeanFreePath by CrossSectionPerVolume 
-                  (minor CPU speadup for compound materials)
-G4PAIModel, G4PAIPhotonModel - remove usage of random numbers at 
-                   initialisation (potential non-reproducibility)
-G4WentzelVIModel - use generic methods of G4VMscModel to access safety
-                   and other geometry information 
 
 24 November 08: V.Ivant (emstand-V09-01-45)
Index: trunk/source/processes/electromagnetic/standard/include/G4ASTARStopping.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4ASTARStopping.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4ASTARStopping.hh	(revision 991)
@@ -25,5 +25,5 @@
 //
 // $Id: G4ASTARStopping.hh,v 1.6 2008/11/13 12:04:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-02 $
 
 #ifndef G4ASTARStopping_h
Index: trunk/source/processes/electromagnetic/standard/include/G4BetheBlochModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4BetheBlochModel.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4BetheBlochModel.hh	(revision 991)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BetheBlochModel.hh,v 1.17 2009/02/20 12:06:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4BetheBlochModel.hh,v 1.16 2008/10/22 16:00:57 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
@@ -82,6 +82,6 @@
   virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
 
-  virtual G4double MinEnergyCut(const G4ParticleDefinition*,
-				const G4MaterialCutsCouple*);
+  G4double MinEnergyCut(const G4ParticleDefinition*,
+			const G4MaterialCutsCouple*);
 			
   virtual G4double ComputeCrossSectionPerElectron(
@@ -131,6 +131,6 @@
 protected:
 
-  virtual G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
-				      G4double kinEnergy);
+  G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
+			      G4double kinEnergy);
 
 private:
@@ -166,3 +166,16 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
+inline G4double G4BetheBlochModel::MaxSecondaryEnergy(
+          const G4ParticleDefinition* pd,
+                G4double kinEnergy) 
+{
+  if(isIon) SetParticle(pd);
+  G4double tau  = kinEnergy/mass;
+  G4double tmax = 2.0*electron_mass_c2*tau*(tau + 2.) /
+                  (1. + 2.0*(tau + 1.)*ratio + ratio*ratio);
+  return std::min(tmax,tlimit);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
 #endif
Index: trunk/source/processes/electromagnetic/standard/include/G4BetheHeitlerModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4BetheHeitlerModel.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4BetheHeitlerModel.hh	(revision 991)
@@ -25,5 +25,5 @@
 //
 // $Id: G4BetheHeitlerModel.hh,v 1.6 2007/05/22 17:34:36 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/include/G4BohrFluctuations.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4BohrFluctuations.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4BohrFluctuations.hh	(revision 991)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BohrFluctuations.hh,v 1.4 2009/02/19 19:17:50 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4BohrFluctuations.hh,v 1.3 2007/09/27 13:53:11 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
@@ -79,4 +79,6 @@
   void InitialiseMe(const G4ParticleDefinition*);
 
+protected:
+
 private:
 
@@ -101,4 +103,25 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
+
+inline G4double G4BohrFluctuations::Dispersion(
+                          const G4Material* material,
+                          const G4DynamicParticle* dp,
+ 				G4double& tmax,
+			        G4double& length)
+{
+  if(!particle) InitialiseMe(dp->GetDefinition());
+
+  G4double electronDensity = material->GetElectronDensity();
+  kineticEnergy = dp->GetKineticEnergy();
+  G4double etot = kineticEnergy + particleMass;
+  beta2 = kineticEnergy*(kineticEnergy + 2.0*particleMass)/(etot*etot);
+  G4double siga  = (1.0/beta2 - 0.5) * twopi_mc2_rcl2 * tmax * length
+                 * electronDensity * chargeSquare;
+
+  return siga;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
 #endif
 
Index: trunk/source/processes/electromagnetic/standard/include/G4BraggIonModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4BraggIonModel.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4BraggIonModel.hh	(revision 991)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BraggIonModel.hh,v 1.12 2009/02/20 12:06:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4BraggIonModel.hh,v 1.11 2008/10/22 16:00:57 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
@@ -77,6 +77,6 @@
   virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
 
-  virtual G4double MinEnergyCut(const G4ParticleDefinition*,
-				const G4MaterialCutsCouple*);
+  G4double MinEnergyCut(const G4ParticleDefinition*,
+			const G4MaterialCutsCouple*);
 			
   virtual G4double ComputeCrossSectionPerElectron(
@@ -128,6 +128,6 @@
 protected:
 
-  virtual G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
-				      G4double kinEnergy);
+  G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
+			      G4double kinEnergy);
 
 private:
@@ -180,4 +180,17 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
+inline G4double G4BraggIonModel::MaxSecondaryEnergy(
+          const G4ParticleDefinition* pd,
+                G4double kinEnergy)
+{
+  if(pd != particle) SetParticle(pd);
+  G4double tau  = kinEnergy/mass;
+  G4double tmax = 2.0*electron_mass_c2*tau*(tau + 2.) /
+                  (1. + 2.0*(tau + 1.)*ratio + ratio*ratio);
+  return tmax;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
+
 inline void G4BraggIonModel::SetParticle(const G4ParticleDefinition* p)
 {
Index: trunk/source/processes/electromagnetic/standard/include/G4BraggModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4BraggModel.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4BraggModel.hh	(revision 991)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BraggModel.hh,v 1.13 2009/02/20 12:06:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4BraggModel.hh,v 1.12 2008/09/14 17:11:48 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
@@ -80,6 +80,6 @@
   virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
 
-  virtual G4double MinEnergyCut(const G4ParticleDefinition*,
-				const G4MaterialCutsCouple*);
+  G4double MinEnergyCut(const G4ParticleDefinition*,
+			const G4MaterialCutsCouple*);
 			
   virtual G4double ComputeCrossSectionPerElectron(
@@ -131,10 +131,10 @@
 protected:
 
-  virtual G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
-				      G4double kinEnergy);
+  G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
+			      G4double kinEnergy);
 
 private:
 
-  inline void SetParticle(const G4ParticleDefinition* p);
+  void SetParticle(const G4ParticleDefinition* p);
 
   G4bool HasMaterial(const G4Material* material);
@@ -182,4 +182,17 @@
   G4bool   isInitialised;
 };
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
+
+inline G4double G4BraggModel::MaxSecondaryEnergy(
+                                            const G4ParticleDefinition* pd,
+                                                  G4double kinEnergy)
+{
+  if(pd != particle) SetParticle(pd);
+  G4double tau  = kinEnergy/mass;
+  G4double tmax = 2.0*electron_mass_c2*tau*(tau + 2.) /
+                  (1. + 2.0*(tau + 1.)*ratio + ratio*ratio);
+  return tmax;
+}
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/source/processes/electromagnetic/standard/include/G4ComptonScattering.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4ComptonScattering.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4ComptonScattering.hh	(revision 991)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4ComptonScattering.hh,v 1.21 2009/02/20 12:06:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4ComptonScattering.hh,v 1.20 2007/05/23 08:47:34 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 //------------------ G4ComptonScattering physics process -----------------------
@@ -82,8 +82,9 @@
 
   // true for Gamma only.  
-  virtual G4bool IsApplicable(const G4ParticleDefinition&);
+  G4bool IsApplicable(const G4ParticleDefinition&);
   
   // Print few lines of informations about the process: validity range,
   virtual void PrintInfo();
+
 
 protected:
@@ -96,4 +97,13 @@
 };
 
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline 
+G4bool G4ComptonScattering::IsApplicable(const G4ParticleDefinition& p)
+{
+  return (&p == G4Gamma::Gamma());
+}
+
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
   
Index: trunk/source/processes/electromagnetic/standard/include/G4ComptonScattering52.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4ComptonScattering52.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4ComptonScattering52.hh	(revision 991)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ComptonScattering52.hh,v 1.4 2007/05/16 14:00:56 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 //------------------ G4ComptonScattering52 physics process -----------------------
Index: trunk/source/processes/electromagnetic/standard/include/G4CoulombScattering.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4CoulombScattering.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4CoulombScattering.hh	(revision 991)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4CoulombScattering.hh,v 1.12 2009/02/20 12:06:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4CoulombScattering.hh,v 1.11 2008/06/13 08:19:43 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
@@ -104,4 +104,11 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
+inline G4bool G4CoulombScattering::IsApplicable(const G4ParticleDefinition& p)
+{
+  return (p.GetPDGCharge() != 0.0 && !p.IsShortLived());
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
 inline void G4CoulombScattering::SetThetaMin(G4double val)
 {
Index: trunk/source/processes/electromagnetic/standard/include/G4CoulombScatteringModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4CoulombScatteringModel.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4CoulombScatteringModel.hh	(revision 991)
@@ -25,5 +25,5 @@
 //
 // $Id: G4CoulombScatteringModel.hh,v 1.15 2008/07/31 13:11:34 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/include/G4GammaConversion.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4GammaConversion.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4GammaConversion.hh	(revision 991)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GammaConversion.hh,v 1.23 2009/02/20 12:06:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GammaConversion.hh,v 1.22 2007/05/23 08:47:34 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 //
@@ -85,5 +85,5 @@
 
   // true for Gamma only.
-  virtual G4bool IsApplicable(const G4ParticleDefinition&);
+  G4bool IsApplicable(const G4ParticleDefinition&);
 
   // Print few lines of informations about the process: validity range,
@@ -99,4 +99,12 @@
 };
 
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4bool G4GammaConversion::IsApplicable(const G4ParticleDefinition& p)
+{
+  return (&p == G4Gamma::Gamma());
+}
+
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
   
Index: trunk/source/processes/electromagnetic/standard/include/G4InitXscPAI.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4InitXscPAI.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4InitXscPAI.hh	(revision 991)
@@ -26,5 +26,5 @@
 //
 // $Id: G4InitXscPAI.hh,v 1.8 2006/06/29 19:50:22 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // 
Index: trunk/source/processes/electromagnetic/standard/include/G4IonFluctuations.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4IonFluctuations.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4IonFluctuations.hh	(revision 991)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4IonFluctuations.hh,v 1.9 2009/02/19 19:17:50 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4IonFluctuations.hh,v 1.8 2008/10/22 16:04:33 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
@@ -84,5 +84,5 @@
 
   // Initialisation prestep
-  void SetParticleAndCharge(const G4ParticleDefinition*, G4double q2);
+  inline void SetParticleAndCharge(const G4ParticleDefinition*, G4double q2);
 
 private:
@@ -117,4 +117,20 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
+inline
+void G4IonFluctuations::SetParticleAndCharge(const G4ParticleDefinition* part,
+					     G4double q2)
+{
+  if(part != particle) {
+    particle       = part;
+    particleMass   = part->GetPDGMass();
+    charge         = part->GetPDGCharge()/eplus;
+    chargeSquare   = charge*charge;
+  }
+  effChargeSquare  = q2;
+  uniFluct.SetParticleAndCharge(part, q2);
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
 #endif
 
Index: trunk/source/processes/electromagnetic/standard/include/G4KleinNishinaCompton.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4KleinNishinaCompton.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4KleinNishinaCompton.hh	(revision 991)
@@ -25,5 +25,5 @@
 //
 // $Id: G4KleinNishinaCompton.hh,v 1.9 2007/05/22 17:34:36 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/include/G4MollerBhabhaModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4MollerBhabhaModel.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4MollerBhabhaModel.hh	(revision 991)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4MollerBhabhaModel.hh,v 1.20 2009/02/20 12:06:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4MollerBhabhaModel.hh,v 1.19 2007/05/22 17:34:36 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
@@ -74,6 +74,6 @@
   virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
 
-  virtual G4double MinEnergyCut(const G4ParticleDefinition*,
-				const G4MaterialCutsCouple*);
+  G4double MinEnergyCut(const G4ParticleDefinition*,
+			const G4MaterialCutsCouple*);
 				
   virtual G4double ComputeCrossSectionPerElectron(
@@ -109,8 +109,8 @@
 protected:
 
-  virtual G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
-				      G4double kinEnergy);
+  G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
+			      G4double kinEnergy);
 			      
-  inline void SetParticle(const G4ParticleDefinition* p);			      
+  void SetParticle(const G4ParticleDefinition* p);			      
 
   const G4ParticleDefinition* particle;
@@ -127,15 +127,15 @@
   G4MollerBhabhaModel & operator=(const  G4MollerBhabhaModel &right);
   G4MollerBhabhaModel(const  G4MollerBhabhaModel&);
-
-  G4bool   isInitialised;
-
 };
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
-inline void G4MollerBhabhaModel::SetParticle(const G4ParticleDefinition* p)
+inline G4double G4MollerBhabhaModel::MaxSecondaryEnergy(
+                                                   const G4ParticleDefinition*,
+                                                         G4double kinEnergy) 
 {
-  particle = p;
-  if(p != theElectron) isElectron = false;
+  G4double tmax = kinEnergy;
+  if(isElectron) tmax *= 0.5;
+  return tmax;
 }
 
Index: trunk/source/processes/electromagnetic/standard/include/G4MscModel71.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4MscModel71.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4MscModel71.hh	(revision 991)
@@ -25,5 +25,5 @@
 //
 // $Id: G4MscModel71.hh,v 1.5 2007/05/22 17:34:36 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/include/G4MultipleScattering.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4MultipleScattering.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4MultipleScattering.hh	(revision 991)
@@ -25,5 +25,5 @@
 //
 // $Id: G4MultipleScattering.hh,v 1.36 2008/03/10 10:39:21 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -----------------------------------------------------------------------------
Index: trunk/source/processes/electromagnetic/standard/include/G4MultipleScattering71.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4MultipleScattering71.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4MultipleScattering71.hh	(revision 991)
@@ -25,5 +25,5 @@
 //
 // $Id: G4MultipleScattering71.hh,v 1.6 2008/07/16 11:27:41 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 //
@@ -59,5 +59,5 @@
 //
 // $Id: G4MultipleScattering71.hh,v 1.6 2008/07/16 11:27:41 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-02 $
 
 // class description
Index: trunk/source/processes/electromagnetic/standard/include/G4PAIModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4PAIModel.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4PAIModel.hh	(revision 991)
@@ -24,6 +24,4 @@
 // ********************************************************************
 //
-// $Id: G4PAIModel.hh,v 1.22 2009/02/19 19:17:50 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 // -------------------------------------------------------------------
@@ -77,12 +75,12 @@
   virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
 
-  virtual void InitialiseMe(const G4ParticleDefinition*);
-
-  virtual G4double ComputeDEDXPerVolume(const G4Material*,
+  virtual void InitialiseMe(const G4ParticleDefinition*) {};
+
+  virtual G4double ComputeDEDX(const G4MaterialCutsCouple*,
 			       const G4ParticleDefinition*,
 			       G4double kineticEnergy,
 			       G4double cutEnergy);
 
-  virtual G4double CrossSectionPerVolume(const G4Material*,
+  virtual G4double CrossSection(const G4MaterialCutsCouple*,
 				const G4ParticleDefinition*,
 				G4double kineticEnergy,
@@ -120,4 +118,6 @@
 
   void SetVerboseLevel(G4int verbose){fVerbose=verbose;};
+
+
 
 protected:
@@ -192,4 +192,28 @@
 };
 
+/////////////////////////////////////////////////////////////////////
+
+inline G4double G4PAIModel::MaxSecondaryEnergy( const G4ParticleDefinition* p,
+                                                      G4double kinEnergy) 
+{
+  G4double tmax = kinEnergy;
+  if(p == fElectron) tmax *= 0.5;
+  else if(p != fPositron) { 
+    G4double mass = p->GetPDGMass();
+    G4double ratio= electron_mass_c2/mass;
+    G4double gamma= kinEnergy/mass + 1.0;
+    tmax = 2.0*electron_mass_c2*(gamma*gamma - 1.) /
+                  (1. + 2.0*gamma*ratio + ratio*ratio);
+  }
+  return tmax;
+}
+
+///////////////////////////////////////////////////////////////
+
+inline  void G4PAIModel::DefineForRegion(const G4Region* r) 
+{
+  fPAIRegionVector.push_back(r);
+}
+
 #endif
 
Index: trunk/source/processes/electromagnetic/standard/include/G4PAIPhotonModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4PAIPhotonModel.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4PAIPhotonModel.hh	(revision 991)
@@ -24,6 +24,4 @@
 // ********************************************************************
 //
-// $Id: G4PAIPhotonModel.hh,v 1.12 2009/02/19 19:17:50 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 // -------------------------------------------------------------------
@@ -76,16 +74,16 @@
   virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
   
-  virtual void InitialiseMe(const G4ParticleDefinition*);
-
-  virtual G4double ComputeDEDXPerVolume(const G4Material*,
-					const G4ParticleDefinition*,
-					G4double kineticEnergy,
-					G4double cutEnergy);
-
-  virtual G4double CrossSectionPerVolume(const G4Material*,
-					 const G4ParticleDefinition*,
-					 G4double kineticEnergy,
-					 G4double cutEnergy,
-					 G4double maxEnergy);
+  virtual void InitialiseMe(const G4ParticleDefinition*) {};
+
+  virtual G4double ComputeDEDX(const G4MaterialCutsCouple*,
+			       const G4ParticleDefinition*,
+			       G4double kineticEnergy,
+			       G4double cutEnergy);
+
+  virtual G4double CrossSection(const G4MaterialCutsCouple*,
+				const G4ParticleDefinition*,
+				G4double kineticEnergy,
+				G4double cutEnergy,
+				G4double maxEnergy);
 
   virtual void SampleSecondaries(std::vector<G4DynamicParticle*>*,
@@ -124,8 +122,10 @@
                              G4double position, G4int iTransfer );
 
+
+
 protected:
 
   G4double MaxSecondaryEnergy(const G4ParticleDefinition*,
-			      G4double kinEnergy);
+                                    G4double kinEnergy);
 
 private:
@@ -145,4 +145,6 @@
   G4int                fVerbose; 
   G4PhysicsLogVector*  fProtonEnergyVector ;
+
+
 
   // vectors
@@ -202,4 +204,28 @@
 };
 
+/////////////////////////////////////////////////////////////////////
+
+inline G4double G4PAIPhotonModel::MaxSecondaryEnergy( const G4ParticleDefinition* p,
+                                                      G4double kinEnergy) 
+{
+  G4double tmax = kinEnergy;
+  if(p == fElectron) tmax *= 0.5;
+  else if(p != fPositron) { 
+    G4double mass = p->GetPDGMass();
+    G4double ratio= electron_mass_c2/mass;
+    G4double gamma= kinEnergy/mass + 1.0;
+    tmax = 2.0*electron_mass_c2*(gamma*gamma - 1.) /
+                  (1. + 2.0*gamma*ratio + ratio*ratio);
+  }
+  return tmax;
+}
+
+///////////////////////////////////////////////////////////////
+
+inline  void G4PAIPhotonModel::DefineForRegion(const G4Region* r) 
+{
+  fPAIRegionVector.push_back(r);
+}
+
 #endif
 
Index: trunk/source/processes/electromagnetic/standard/include/G4PAIxSection.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4PAIxSection.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4PAIxSection.hh	(revision 991)
@@ -26,5 +26,5 @@
 //
 // $Id: G4PAIxSection.hh,v 1.15 2008/05/30 16:04:40 grichine Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // 
Index: trunk/source/processes/electromagnetic/standard/include/G4PAIySection.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4PAIySection.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4PAIySection.hh	(revision 991)
@@ -26,5 +26,5 @@
 //
 // $Id: G4PAIySection.hh,v 1.1 2007/10/01 17:45:14 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // 
Index: trunk/source/processes/electromagnetic/standard/include/G4PEEffectModel.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4PEEffectModel.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4PEEffectModel.hh	(revision 991)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4PEEffectModel.hh,v 1.7 2009/02/20 12:06:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4PEEffectModel.hh,v 1.6 2007/05/22 17:34:36 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-02 $
 //
 // -------------------------------------------------------------------
@@ -41,6 +41,4 @@
 //
 // 06.02.2006 : added ComputeMeanFreePath()  (mma)
-// 20.02.2009 : move virtual inline to .cc, substitute
-//              ComputeMeanFreePath() by CrossSectionPerVolume (VI)
 //
 // Class Description:
@@ -72,15 +70,14 @@
   virtual void Initialise(const G4ParticleDefinition*, const G4DataVector&);
 
-  virtual G4double ComputeCrossSectionPerAtom(const G4ParticleDefinition*,
-					      G4double kinEnergy,
-					      G4double Z,
-					      G4double A,
-					      G4double, G4double);
+  G4double ComputeCrossSectionPerAtom(const G4ParticleDefinition*,
+                                      G4double kinEnergy,
+                                      G4double Z,
+                                      G4double A,
+                                      G4double, G4double);
 				      
-  virtual G4double CrossSectionPerVolume(const G4Material*,
-					 const G4ParticleDefinition*,
-					 G4double kineticEnergy,
-					 G4double cutEnergy,
-					 G4double maxEnergy);
+  G4double ComputeMeanFreePath( const G4ParticleDefinition*,
+                                      G4double kinEnergy,
+				const G4Material* material,      
+                                      G4double, G4double);
 
   virtual void SampleSecondaries(std::vector<G4DynamicParticle*>*,
@@ -103,4 +100,43 @@
 };
 
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo.....
+
+inline G4double G4PEEffectModel::ComputeCrossSectionPerAtom(
+                                       const G4ParticleDefinition*,
+                                             G4double energy,
+                                             G4double Z, G4double,
+                                             G4double, G4double)
+{
+ G4double* SandiaCof = G4SandiaTable::GetSandiaCofPerAtom((G4int)Z, energy);
+
+ G4double energy2 = energy*energy, energy3 = energy*energy2,
+          energy4 = energy2*energy2;
+
+ return SandiaCof[0]/energy  + SandiaCof[1]/energy2 +
+        SandiaCof[2]/energy3 + SandiaCof[3]/energy4;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
+
+inline G4double G4PEEffectModel::ComputeMeanFreePath(
+                                       const G4ParticleDefinition*,
+                                             G4double energy,
+				       const G4Material* material,
+                                             G4double, G4double)
+{
+ G4double* SandiaCof = material->GetSandiaTable()
+                                ->GetSandiaCofForMaterial(energy);
+				
+ G4double energy2 = energy*energy, energy3 = energy*energy2,
+          energy4 = energy2*energy2;
+	  
+ G4double cross = SandiaCof[0]/energy  + SandiaCof[1]/energy2 +
+                  SandiaCof[2]/energy3 + SandiaCof[3]/energy4; 
+ 
+ G4double mfp = DBL_MAX;
+ if (cross > 0.) mfp = 1./cross;
+ return mfp;
+}
+
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
Index: trunk/source/processes/electromagnetic/standard/include/G4PSTARStopping.hh
===================================================================
--- trunk/source/processes/electromagnetic/standard/include/G4PSTARStopping.hh	(revision 968)
+++ trunk/source/processes/electromagnetic/standard/include/G4PSTARStopping.hh	(revision 991)
@@ -25,5 +25,5 @@
 //
 // $Id: G4PSTARStopping.hh,v 1.5 2008/11/13 12:04:37 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-02 $
 
 #ifndef G4PSTARStopping_h
